package cokr.xit.fims.payer.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.payer.Payer;
import cokr.xit.fims.payer.PayerQuery;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 납부자 대장 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-18	mjkhan 최초 작성
 * ================================
 * </pre>
 */
@Mapper("payerMapper")
public interface PayerMapper extends AbstractMapper {
	/**지정한 조건에 따라 납부자 대장 목록을 조회하여 반환한다.<br />
	 * @param req 납부자 대장 조회 조건
	 * @return 납부자 대장 목록
	 */
	List<DataObject> selectPayerList(PayerQuery req);

	/**지정한 조건에 따라 납부자 대장 객체들을 반환한다.
	 * @param req 납부자 대장 조회 조건
	 * @return 납부자 대장 객체 목록
	 */
	List<Payer> selectPayers(PayerQuery req);

	/**납부자 대장 정보를 등록한다.
	 * @param payer 납부자 대장
	 * @return 저장된 정보수
	 */
	int insertPayer(Payer payer);

	/**납부자 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"payer" - 납부자 대장</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertHistory(Map<String, Object> params);

	/**납부자 대장 정보를 등록한다.
	 * @param payer 납부자 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(Payer payer) {
		boolean saved = insertPayer(payer) > 0;
		if (saved) {
			DataObject params = params().set("payer", payer);
			insertHistory(params);
		}
		return saved;
	}

	/**납부자 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"payer" - 납부자 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updatePayer(Payer payer);

	/**납부자 대장 정보를 수정한다.
	 * @param payer 납부자 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(Payer payer) {
		boolean saved = updatePayer(payer) == 1;
		if (saved) {
			DataObject params = params().set("payer", payer);
			insertHistory(params);
		}
		return saved;
	}

	/**지정한 납부자 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"rtpyrIds" - 납부자 아이디</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deletePayer(Map<String, ?> params);

	/**납부자 대장 정보를 삭제한다.
	 * @param rtpyrIds 납부자 아이디
	 * @return 저장된 정보수
	 */
	default int delete(String... rtpyrIds) {
		return !isEmpty(rtpyrIds) ?  deletePayer(params().set("rtpyrIds", rtpyrIds)) : 0;
	}

	/**납부자 도로명 주소의 우편번호, 건물관리번호를 조회한다. 도로망 주소 연계 구현 시 이동
	 * @param params 파라미터
	 * <ul><li>roadNmCd - 도로명 코드</li>
	 *     <li>udgdSeCd - 지하 구분코드</li>
	 *     <li>bmno - 건물본번</li>
	 *     <li>bsno - 건물부번</li>
	 * </ul>
	 * @return 납부자 도로명 주소의 우편번호, 건물관리번호
	 */
	DataObject selectAddrInfo(Map<String, Object> params);
}